
TYPO3.Flow - Feature # 37373

Status: Under Review Priority: Should have
Author: Karsten Dambekalns Category: Configuration
Created: 2012-05-21 Assigned To: Marc Neuhaus
Updated: 2013-05-21 Due date:
PHP Version:
Has patch: No
Complexity:
Subject: Make annotation overrides / "injection" via Objects.yaml possible
Description

Objects.yaml should allow for adding and overriding annotations in classes. This would allow to modify ORM configuration or anything
else driven through annotations without touching the code - especially useful for 3rd party code.

Related issues:
related to TYPO3.Flow - Bug # 27045: Introduced properties are not available ... New 2011-05-26
related to TYPO3.Flow - Feature # 35354: Additional variants to annotate Vali... Closed 2012-03-29
related to TYPO3.Flow - Feature # 37372: Inheritance in ORM should be configu... Accepted 2012-05-21
related to TYPO3.Flow - Bug # 39413: AOP: Property introduction seems to be b... Resolved 2012-07-31
duplicated by TYPO3.Flow - Feature # 39661: It should be Possible to change A... Closed 2012-08-09

History
#1 - 2012-05-21 16:37 - Karsten Dambekalns

Implementation idea: only ReflectionService needs to know about this, could even offer a way to get rid of specialized handling for things like scope in
Objects.yaml.

#2 - 2012-05-21 16:57 - Adrian Föder

I already mentioned such an idea; so an additional suggestion for this: This feature, imo, must come with a Shell command that shows current
annotations and their origin, because "annotations" now/than can have various origins.

#3 - 2012-08-10 11:55 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549

#4 - 2012-08-10 11:56 - Karsten Dambekalns
- Assigned To set to Marc Neuhaus

#5 - 2012-08-10 12:34 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549
#6 - 2012-08-10 12:54 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549

#7 - 2012-08-10 13:52 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549

#8 - 2012-09-03 11:58 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549

#9 - 2012-09-03 12:32 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549

#10 - 2012-09-11 00:35 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549

#11 - 2012-09-11 13:36 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549

#12 - 2012-09-19 09:52 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549

#13 - 2012-10-19 17:13 - Christopher Hlubek

Can we also set the arguments of the annotations? Just adding an annotation might not be enough for most cases (e.g. validation). Maybe I missed
that in the change or in the test.

#14 - 2012-10-22 00:31 - Christopher Hlubek

The main question for me is, if we want to complicate the whole proxy building even more. Also debugging and traceability is problematic with
overriding the annotations in the PHP class. So maybe we should mark the overridden annotations with a comment
What about using the approach of solving the problem at the consumer side? So instead of just asking the ReflectionService about the information, we
could introduce another source (e.g. ConfigurationManager) which overrides the data from annotations. The problem for me is that we add almost 1000
lines of code for this change in an area which is really complicated (we had / have a lot of bugs and strange effects in there).

#15 - 2012-10-22 11:53 - Marc Neuhaus

Hmm, that kind of sounds like what i had before ^^

I think for quite complex things like expose it makes sense to have a more high-level api layer above the annotations to use for configurations, but i
some cases we might really need a way to change those low-level annotations.

I agree, that debugging gets kind of blurred by this different annotation "sources" and i like the idea to put those information into the proxy through
comments. Here's an example i could imagine:

    /**
     * @param string
     * @Flow\Identity
     * @ORM\Column(name="baz")
     *
     * Overridden Annotations:
     * @Flow\Validate(type="Email")
     * @Flow\Validate(type="NotEmpty")
     *
     * Removed Annotations:
     * Flow\Introduce
     */
    protected $mail;

#16 - 2012-10-22 13:56 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549

#17 - 2012-10-22 13:56 - Marc Neuhaus

I've just pushed a new patch which renders the annotations in the proxies like this:

https://gist.github.com/3931158

:)

#18 - 2012-11-27 23:55 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13549

#19 - 2012-12-10 13:11 - Karsten Dambekalns
- Target version changed from 2.0 beta 1 to 2.1

#20 - 2013-05-21 13:28 - Robert Lemke
- Target version deleted (2.1)
